%global xmlxsdver 2009/01

Summary:       Common SGML catalog and DTD files
Name:          sgml-common
Version:       0.6.3
Release:       6%{?dist}
License:       GPL+
#There is no homepage of this project, URL page includes complete ISO 8879,
#only part of it is included in sgml-common package.
URL:           https://www.w3.org/2003/entities/
Source0:       https://www.sourceware.org/pub/docbook-tools/new-trials/SOURCES/%{name}-%{version}.tgz
# Following 4 from openjade/pubtext
Source1:       xml.dcl
Source2:       xml.soc
Source3:       html.dcl
Source4:       html.soc
Source5:       http://www.w3.org/%{xmlxsdver}/xml.xsd
Source6:       http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd
Source7:       http://www.w3.org/2001/XMLSchema.dtd
Source8:       http://www.w3.org/2001/datatypes.dtd
Source9:       sgmlwhich.1
Source10:      sgml.conf.5
Patch3000:     sgml-common-umask.patch
Patch3001:     sgml-common-xmldir.patch
Patch3002:     sgml-common-quotes.patch

BuildRequires: make automake
BuildRequires: libxml2
Requires:      /usr/bin/basename
BuildArch:     noarch

%description
sgml-common package contains a collection of entities and DTDs
for processing SGML, needed by packages such as jade and so on.
Sgml-common also includes an up-to-date Open Catalog file.


%package -n xml-common
Summary:       Common XML catalog and DTD files
License:       GPL+
Requires(pre): /usr/bin/xmlcatalog

%description -n xml-common
The xml-common is a subpackage of sgml-common which contains
a collection XML catalogs that are useful for processing XML,
but that don't need to be included in main package.


%prep
%autosetup -p1
# replace bogus links with files
automakedir=`ls -1d /usr/share/automake* | head -n +1`
for file in COPYING INSTALL install-sh missing mkinstalldirs; do
   rm $file
   cp -p $automakedir/$file .
done


%build
%configure


%install
%make_install htmldir='%{_datadir}/doc'
mkdir %{buildroot}%{_sysconfdir}/xml
mkdir -p %{buildroot}%{_sysconfdir}/sgml/docbook
mkdir -p %{buildroot}%{_datadir}/sgml/docbook
touch %{buildroot}%{_sysconfdir}/sgml/catalog
# Create an empty XML catalog.
XMLCATALOG=%{buildroot}%{_sysconfdir}/xml/catalog
xmlcatalog --noout --create $XMLCATALOG

for type in system uri ; do
	for path in 2001 %{xmlxsdver} ; do
		xmlcatalog --noout --add $type \
			"http://www.w3.org/$path/xml.xsd" \
			"file://%{_datadir}/xml/xml.xsd" $XMLCATALOG
	done
	xmlcatalog --noout --add $type \
		"http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd" \
		"file://%{_datadir}/xml/xmldsig-core-schema.xsd" $XMLCATALOG
done
# Put the common DocBook entries
xmlcatalog --noout --add "delegatePublic" \
	"-//OASIS//ENTITIES DocBook XML" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
xmlcatalog --noout --add "delegatePublic" \
	"-//OASIS//DTD DocBook XML" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
xmlcatalog --noout --add "delegatePublic" \
	"ISO 8879:1986" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
xmlcatalog --noout --add "delegateSystem" \
	"http://www.oasis-open.org/docbook/" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
xmlcatalog --noout --add "delegateURI" \
	"http://www.oasis-open.org/docbook/" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
for public in "-//W3C//DTD XMLSchema 200102//EN" "-//W3C//DTD XMLSCHEMA 200102//EN" ; do
	xmlcatalog --noout --add "public" \
		"$public" \
		"file://%{_datadir}/xml/XMLSchema.dtd" $XMLCATALOG
done
xmlcatalog --noout --add "system" \
	"http://www.w3.org/2001/XMLSchema.dtd" \
	"file://%{_datadir}/xml/XMLSchema.dtd" $XMLCATALOG

# Create the common DocBook catalog
xmlcatalog --noout --create %{buildroot}%{_sysconfdir}/sgml/docbook/xmlcatalog
ln -sf %{_sysconfdir}/sgml/docbook/xmlcatalog %{buildroot}%{_datadir}/sgml/docbook/xmlcatalog

rm -f %{buildroot}%{_datadir}/sgml/xml.dcl
install -p -m0644 %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} %{buildroot}%{_datadir}/sgml

rm -rf $RPM_BUILD_ROOT%{_datadir}/xml/*
install -p -m0644 %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE8} %{buildroot}%{_datadir}/xml

mkdir -p %{buildroot}%{_mandir}/man{1,5}
install -p -m0644 %{SOURCE9} %{buildroot}%{_mandir}/man1
install -p -m0644 %{SOURCE10} %{buildroot}%{_mandir}/man5

rm $RPM_BUILD_ROOT%{_datadir}/doc/*.html
rm -rf __dist_doc/html
mkdir -p __dist_doc/html
cp -p doc/HTML/*.html __dist_doc/html/


%pre -n xml-common
if [ $1 -gt 1 ] && [ -e %{_sysconfdir}/xml/catalog ]; then
	for type in system uri ; do
		for path in 2001 %{xmlxsdver} ; do
			xmlcatalog --noout --add $type \
				"http://www.w3.org/$path/xml.xsd" \
				"file://%{_datadir}/xml/xml.xsd" \
				%{_sysconfdir}/xml/catalog
		done
		xmlcatalog --noout --add $type \
			"http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd" \
			"file://%{_datadir}/xml/xmldsig-core-schema.xsd" %{_sysconfdir}/xml/catalog
	done
	for public in "-//W3C//DTD XMLSchema 200102//EN" "-//W3C//DTD XMLSCHEMA 200102//EN" ; do
		xmlcatalog --noout --add "public" \
			"$public" \
			"file://%{_datadir}/xml/XMLSchema.dtd" %{_sysconfdir}/xml/catalog
	done
fi


%files
%license COPYING
%doc __dist_doc/html/ AUTHORS NEWS ChangeLog README
%dir %{_sysconfdir}/sgml
%config(noreplace) %{_sysconfdir}/sgml/sgml.conf
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) %{_sysconfdir}/sgml/catalog
%dir %{_datadir}/sgml
%dir %{_datadir}/sgml/sgml-iso-entities-8879.1986
%{_datadir}/sgml/sgml-iso-entities-8879.1986/*
%{_datadir}/sgml/xml.dcl
%{_datadir}/sgml/xml.soc
%{_datadir}/sgml/html.dcl
%{_datadir}/sgml/html.soc
%{_bindir}/sgmlwhich
%{_bindir}/install-catalog
%{_mandir}/man8/install-catalog.8*
%{_mandir}/man1/sgmlwhich.1*
%{_mandir}/man5/sgml.conf.5*


%files -n xml-common
%license COPYING
%doc AUTHORS NEWS ChangeLog README
%dir %{_sysconfdir}/xml
%dir %{_sysconfdir}/sgml
%dir %{_sysconfdir}/sgml/docbook
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xml/catalog
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sgml/docbook/xmlcatalog
%dir %{_datadir}/sgml
%dir %{_datadir}/sgml/docbook
%{_datadir}/sgml/docbook/xmlcatalog
%dir %{_datadir}/xml
%{_datadir}/xml/xml.xsd
%{_datadir}/xml/xmldsig-core-schema.xsd
%{_datadir}/xml/XMLSchema.dtd
%{_datadir}/xml/datatypes.dtd


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.3-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.3-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.3-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.3-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.3-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Jul 14 2022 rockerzhu <rockerzhu@tencent.com> - 0.6.3-1
- Initial build
